/****************************************************************************************
  * Yoko Ebata's work in 2019, m259 data visualization
  *
  * Much of the credit is owed to Rodger Luo, fundamentally extracting from his 
  * demo project with spl's top 25 dvd's, then deriving it into my own intepretation of code and data 
  * 
  * 
  * This 2D Meditation Dewey project serves to visualize the different Dewey Classes
  * on the topic of meditation & mindfulness. With the intentions of creating a visual data
  * of Dewey classes all across what exists, I wanted to observe the behaviors of checkouts
  * in relation to its assigned Dewey classes and year. 
  *
*****************************************************************************************/


Table table;
int rows, cols;

float constantHmargin = 100;
float constantVmargin = 100;

float cellWidth = 50;
float cellHeight = 50;
float[][] dataMatrix;
float min, max;

String[] deweys;
int[] checkouts;

PImage gradient;

PFont font;


void setup() {
  size(1280, 720);
  surface.setResizable(true);
  font = createFont("UniversLTStd", 10);
  
  table = loadTable("meditationDeweys.csv", "header");
  gradient = loadImage("gradient.png");
  
  rows = table.getRowCount();
  cols = table.getColumnCount();
  
  println("Rows: " + rows + "Columns: " + cols);
  
  
  dataMatrix = new float[rows][cols-1];
  deweys = new String[rows];
  checkouts = new int[rows];
  
 for(int i=0; i<rows; i++){
   for(int j=0; j<cols-1; j++){
     dataMatrix[i][j] = table.getFloat(i, j+1);
     deweys[i] = table.getString(i,0);
   
   
   //TableRow row = table.getRow(i);
   //float d = row.getFloat("deweys");
   //float s = row.getFloat("2017");
   //float e = row.getFloat("2018");
   
      //max value
     if(dataMatrix[i][j] > max){
       max = dataMatrix[i][j];
     }
   }
   
     deweys[i] = table.getString(i,0);
     checkouts[i] = table.getInt(i, 1);
 }
  
     //min value
      min = 0;
        //for(int i=0; i<dataMatrix.length; i++){
        //for(int j=0; j<dataMatrix[0].length; j++){
        //    if(dataMatrix[i][j] < max){
        //      max = dataMatrix[i][j];
      
    
  

    println("Max Value is " + max);
    println("Min Value is " + min);

    cellWidth = (width - constantHmargin*2)/(cols-1);
    cellHeight = (height - constantVmargin*2)/rows;

}

void draw() {
  
  background(220);
  
  //title
  textAlign(CENTER, CENTER);
  textSize(16);
  text("MEDITATION DEWEY TRENDS (2008-2018)", width/2, constantVmargin/2);
  
  
  for(int i=0; i<dataMatrix.length; i++){
    for(int j=0; j<dataMatrix[i].length; j++){
       //System.out.println(i+" " +j);
       color c = gradient.get((int)map(dataMatrix[i][j], min, max, gradient.width-2, 1), gradient.height/2);
        fill(c);
        noStroke();
        rect(constantHmargin + cellWidth*j, constantVmargin + cellHeight*i, cellWidth, cellHeight);
      }
    }
  
  //Draw vertical labels
  for(int i=0; i<rows; i++){
    textAlign(RIGHT, CENTER);
    fill(0);
    textSize(10);
    text(deweys[i], constantHmargin-30, constantVmargin +cellHeight*(0.5+i));
    
  }
  
  for(int i=12; i<rows; i++){
    textAlign(RIGHT, CENTER);
    fill(0);
    textSize(10);
    text(deweys[i], constantHmargin, constantVmargin +cellHeight*(0.5+i));
    
  }
 
 Table something = loadTable("meditationDeweys.csv");
  //Draw horizontal labels
  for(int i=1; i<12; i++){
    textSize(10);
    textAlign(CENTER, TOP);
    fill(0);
    text(something.getString(0,i), constantHmargin + (i*cellWidth/2) + ((i - 1)*(cellWidth))/2, 630);  
         
         
    //draw the seperation lines
    //if(i != 0){
    //  stroke(#009EE5);
    //  line(constantHmargin + cellWidth*(12*i), constantVmargin +cellHeight*rows + 3,  
    //       constantHmargin + cellWidth*(12*i), constantVmargin +cellHeight*rows + 20);
    }
  
  }
